<script>
  const widthBoxDiv = $("div.test-percentage-boxplot").width() - 120;

  function renderTestsPercentagesBoxPlot(data) {

    let scoreData = data.map(d => d.scores);

    const marginBox = {
        top: 0,
        right: 40,
        bottom: 80,
        left: 40
      },
      heightBox = 400 - marginBox.top - marginBox.bottom;

    const boxSpace = 85;

    const width = d3.max([scoreData.length * boxSpace, widthBoxDiv]);
    const widthBox = d3.max([boxSpace, widthBoxDiv / scoreData.length]) - marginBox.left - marginBox.right;

    let min = Infinity,
      max = -Infinity;

    const chart = d3.box()
      .whiskers(iqr(1.5))
      .width(widthBox)
      .height(heightBox);

    scoreData.forEach(scores => {
      let rowMax = d3.max(scores);
      let rowMin = d3.min(scores);
      if (rowMax > max) max = rowMax;
      if (rowMin < min) min = rowMin;
    });
    chart.domain([min, max]);

    const margin = {
        top: 10,
        right: 20,
        bottom: 50,
        left: 70
      },
      margin2 = {
        top: 300,
        right: 20,
        bottom: 50,
        left: 70
      },
      height = 400 - margin.top - margin.bottom,
      height2 = 600 - margin2.top - margin2.bottom;

    const svg = d3.select('div.test-percentage-boxplot').append('svg')
      .attr('width', width + margin.left + margin.right)
      .attr('height', height + margin.top + margin.bottom)

    const focus = svg.append('g')
      .attr("class", "focus")
      .attr('transform', `translate(${margin.left}, ${margin.top})`);

    const xScale = d3.scaleBand()
      .domain(data.map(d => d.title_abbrev))
      .range([0, width])
      .paddingInner(0);

    focus.selectAll("g.hover")
      .data(data)
      .enter().append("g")
      .attr("class", "hover")
      .append("rect")
      .attr("fill", "none")
      .attr("width", xScale.bandwidth())
      .attr("height", heightBox + marginBox.bottom + marginBox.top)
      .attr("transform", (d) => {
        return "translate(" + xScale(d.title_abbrev) + "," + marginBox.top + ")"
      })
      .attr("pointer-events", "all")
      .style("cursor", "pointer")
      .on("mouseover", (d) => {
        const tooltip = d3.select(".tooltip-boxplot-box");
        tooltip.transition()
          .duration(200)
          .style("opacity", .8);
        tooltip.html(`<b>ID: ${d.id}</b><br/><b>${d.title}</b>`)
          .style("left", (d3.event.pageX + 10) + "px")
          .style("top", (d3.event.pageY - 20) + "px");
      })
      .on("mouseout", () => {
        const tooltip = d3.select(".tooltip-boxplot-box");
        tooltip.transition()
          .duration(200)
          .style("opacity", 0);
      })
      .on("mousemove", () => {
        const tooltip = d3.select(".tooltip-boxplot-box");
        tooltip.style("left", (d3.event.pageX + 10) + "px")
          .style("top", (d3.event.pageY - 20) + "px");
      })
      .on("click", (d) => {
        selectTest(d.id, d.title);
      });

    const chartGroup = focus.selectAll("g.box")
      .data(data)
      .enter().append("g")
      .attr("class", "box")
      .attr("width", widthBox + marginBox.left + marginBox.right)
      .attr("height", heightBox + marginBox.bottom + marginBox.top)
      .append("g")
      .attr("transform", (d, i) => {
        return "translate(" + (xScale(d.title_abbrev) + xScale.bandwidth() / 2 - widthBox / 2) + "," + marginBox.top + ")"
      })
      .call(chart);

    const yScale = d3.scaleLinear()
      .domain([min, max])
      .range([heightBox, 0]);

    const yAxis = d3.axisLeft(yScale).tickFormat(d3.format(".0%"));;
    focus.append("g")
      .attr("class", "y-axis-boxplot")
      .call(yAxis);

    focus.append("text")
      .attr("class", "y-axis-label-boxplot")
      .attr("text-anchor", "middle")
      .attr("transform", `translate(${-45}, ${height/2}) rotate(-90)`)
      .text("Exam score")
      .attr("font-family", "sans-serif")
      .attr("font-size", "15px");

    focus.append("text")
      .attr("class", "x-axis-label-barchart")
      .attr("text-anchor", "middle")
      .attr("transform", `translate(${width/2}, ${height + margin.bottom})`)
      .text("Exam title")
      .attr("font-family", "sans-serif")
      .attr("font-size", "15px");

    const xAxis = d3.axisBottom(xScale);
    focus.append("g")
      .attr("class", "x-axis-boxplot")
      .attr("transform", `translate(0, ${height})`)
      .call(xAxis);

    d3.select("body").append("div")
      .attr("class", "tooltip-sm tooltip-boxplot-outlier")
      .style("opacity", 0);

    d3.select("body").append("div")
      .attr("class", "tooltip-lg tooltip-boxplot-box")
      .style("opacity", 0);

    // Returns a function to compute the interquartile range.
    function iqr(k) {
      return function(d, i) {
        var q1 = d.quartiles[0],
          q3 = d.quartiles[2],
          iqr = (q3 - q1) * k,
          i = -1,
          j = d.length;
        while (d[++i] < q1 - iqr);
        while (d[--j] > q3 + iqr);
        return [i, j];
      };
    }
  }
</script>